<template>
  <div class="favourite-users">
    <UserList
      :users="users"
      :headers="listHeaders" />
      <ButtonComponent
        @click="onExportCSV"
        :disabled="!users.length"
        label="Exportar a CSV">
      </ButtonComponent>
  </div>
</template>

<script>
// @ is an alias to /src
import UserList from '@/components/UserList.vue';
import ButtonComponent from '@/components/ButtonComponent.vue';
import { mapGetters } from 'vuex';

export default {
  name: 'FavouriteUsers',
  components: {
    UserList,
    ButtonComponent,
  },
  data() {
    return {
      listHeaders: ['Gender', 'Nombre', 'Email', 'Nacionalidad', 'Fecha de Nacimiento', 'Fecha de Registro'],
    };
  },
  computed: {
    ...mapGetters({
      users: 'favouriteUserDataList',
    }),
    csvData() {
      return this.users.map((user) => ({
        genero: user.gender,
        nombre: user.name,
        email: user.email,
        nacionalidad: user.nationality,
        fecha_nacimiento: user.birthDate,
        fecha_registro: user.registeredDate,
      }));
    },
  },
  methods: {
    onExportCSV() {
      let csvContent = 'data:text/csv;charset=utf-8,';
      csvContent += [
        Object.keys(this.csvData[0]).join(';'),
        ...this.csvData.map((data) => Object.values(data).join(';')),
      ].join('\n').replace(/(^\[)|(\]$)/gm, '');

      const data = encodeURI(csvContent);
      const link = document.createElement('a');
      link.setAttribute('href', data);
      link.setAttribute('download', 'export.csv');
      link.click();
    },
  },
};
</script>
